function [cout,preskok]= check_outliers2(c,disexpect)
% CHECK_OUTLIERS2 checks which CTF zeros don't belong to the equidistant
%                 pattern in q2 space
%
% SYNOPSIS:
%   [cout, preskok] = check_outliers2(c,disexpect)
%
% INPUT:
%         c: array of the detected CTF zero positions
% disexpect: the equdistance in pixels (from q2 space)
% OUTPUT:
%     cout: the array of the postion of the rings that belong to the
%              predicted pattern
% preskok: CTF zeros that are skipped in detection


% (C) Copyright 2011
%  Quantitative Imaging Group      Leiden University Medical Center
%  Faculty of Applied Sciences     Department of Molecular Cell Biology
%  Delft University of Technology  Section Electron Microscopy
%  Lorentzweg 1                    2300 RC Leiden
%  2628 CJ Delft
%  The Netherlands
%
%  Milos Vulovic

maxthonskip=3;
Maxerror=0.2;
 equidist(1)=c(1);
for kk=1:length(c)-1
        equidist(kk+1)= c(kk+1)- c(kk); % checking the neigbours
end
distq=abs(median(equidist(2:end)));
%disexpect= 5; %q0^2 of the first zero predicted for the value of defocus from microscope
d1= (distq + disexpect)/2;
% plot(c,R,'r+')
relerror=zeros(1,length(c)-1);
preskok=zeros(1,length(c)-1);
d=preskok;
d(1)=d1;
izbaceni=[];
kk=1;
    while kk <= length(equidist)
    skip=1;
    relerror(kk)=abs(equidist(kk)/(skip*d(kk)));
        
           if relerror(kk)>1 && abs(1-relerror(kk)) > Maxerror %skipped minima
                   while abs(1-relerror(kk)) > Maxerror && skip < maxthonskip
                   skip=skip+1;
                   relerror(kk)=abs(equidist(kk)/(skip*d(kk)));
                   end
               d(kk+1)=(equidist(kk)/skip+d(kk))/2;
               preskok(kk)=skip;
               kk=kk+1;
               
           elseif relerror(kk)<1 && abs(1-relerror(kk)) > Maxerror 
                c(kk)=[];
                
                if kk<length(equidist) && (kk > 1 || kk==1)% in a case outlier is not the first one or the last one 
                %c(kk)=[];
                    if kk>1
                    equidist(kk-1)=[];
                    end
                equidist(kk)=[];
                end
                izbaceni=[izbaceni kk];
                equidist(1)=c(1);
                for pp=1:length(c)-1
                equidist(pp+1)= c(pp+1)- c(pp); % checking the neigbours
                distq=abs(median(equidist(2:end)));
                d1= (distq + disexpect)/2;
                d(1)=d1;
                kk=1;
                end
           else
               d(kk+1)=(equidist(kk)/skip+d(kk))/2;
               preskok(kk)=skip;
               kk=kk+1;
           end 
    end
%   c(izbaceni)=[];
%   equidist(izbaceni-1)=[];
%   equidist(izbaceni)=[];
   
preskok=[ preskok(1:end-length(izbaceni))-1];
relerror(1:end-length(izbaceni));
izbaceni;
cout=c;

