% radius = mk_gauss_cone_cube(radiusstep, processsize, sigmanul, sigmaR  )


function [radius_range, radius] = mk_gauss_cone_cube(radiusstep, processsize, ellipaxratio, elliporient, sigmanul, sigmaR  )


radius_range = [1:radiusstep:processsize/2-1];
Nr = length(radius_range);

sigma = max(radius_range)*sigmanul*sigmaR./(radius_range*(sigmanul-sigmaR)+max(radius_range)*sigmaR);

b1 = sqrt(2/(ellipaxratio^2+1));
a1 = b1*ellipaxratio;

xdot = xx([processsize, processsize])*cos(elliporient) - yy([processsize, processsize])*sin(elliporient);
ydot = xx([processsize, processsize])*sin(elliporient) + yy([processsize, processsize])*cos(elliporient);
tmp = sqrt((xdot/a1 ).^2+(ydot/b1).^2);

%tmp = rr([processsize, processsize]);
radius = newim([processsize, processsize, Nr]);
for ii= 0:Nr-1
   radius_range(ii+1);
   radius(:,:,ii) = (gaussianlineclip(tmp-radius_range(ii+1), sigma(ii+1),0,4)) ./ (2*pi*radius_range(ii+1));
   %radius(:,:,ii) = (gaussianlineclip(tmp-radius_range(ii+1), sigma(ii+1),0,4))./tmp;
   %radius(processsize/2,processsize/2,ii) = 0;
   %radius(:,:,ii) = radius(:,:,ii)/sum(sum(radius(:,:,ii)));
end


% figure;
% plot(radius_range, sigma)

end



